freeslot("sfx_cepun1")
sfxinfo[sfx_cepun1].caption = "Whish"
freeslot("sfx_cepun2")
sfxinfo[sfx_cepun2].caption = "Whaash"
freeslot("sfx_cepun3")
sfxinfo[sfx_cepun3].caption = "Wheesh"
freeslot("sfx_cepun4")
sfxinfo[sfx_cepun4].caption = "Baam"
freeslot("sfx_ceuppr")
sfxinfo[sfx_ceuppr].caption = "Whoosh"
freeslot("sfx_ceshok")
sfxinfo[sfx_ceshok].caption = "Sho-ken!"
freeslot("sfx_cehit1")
sfxinfo[sfx_cehit1].caption = "Damage"
freeslot("sfx_cehit2")
sfxinfo[sfx_cehit2].caption = "Damage"
freeslot("sfx_ceboom")
sfxinfo[sfx_ceboom].caption = "Boom"

// Abilites table for Kirby to eat
if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
// Needle
kirbyabilitytable["cacee"] = 6

//Fang showdown stuff
local caceey = -175
hud.add(function(v, player, cam)
	if player.mo and player.mo.valid and player.mo.caceefang and player.mo.caceefang.valid
		hud.disable("score")
		hud.disable("time")
		hud.disable("rings")
		hud.disable("lives")
		v.drawFill(0,0+caceey, 500, 150, 31|V_SNAPTOLEFT)
		v.drawFill(0,50-caceey, 500, 150, 31|V_SNAPTOLEFT)
		if caceey < -100
			caceey = $+1
		end
	elseif caceey > -175
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
		v.drawFill(0,0+caceey, 500, 150, 31|V_SNAPTOLEFT)
		v.drawFill(0,50-caceey, 500, 150, 31|V_SNAPTOLEFT)
		caceey = $-1
	end
end)
addHook("MapLoad", do
	if not multiplayer and not netgame and gamemap == 15
	and mapheaderinfo[gamemap].lvlttl == "Arid Canyon"
	and mapheaderinfo[gamemap].actnum == 3 and players[0] and players[0].valid
	and players[0].mo and players[0].mo.valid and not (players[1] and players[1].valid)
		for mobj in mobjs.iterate()
			if mobj.type == MT_FANG
				caceey = -175
				players[0].mo.caceefang = mobj
				players[0].mo.state = S_PLAY_CLING
				players[0].mo.angle = ANGLE_225
				players[0].drawangle = ANGLE_225
				players[0].mo.reactiontime = -1
				P_TeleportMove(players[0].mo, -15615*FRACUNIT, 5315*FRACUNIT, 320*FRACUNIT)
				
				local hat = P_SpawnMobjFromMobj(players[0].mo,0,0,0,MT_CACEE_HAT)
				hat.tracer = players[0].mo
				
				mobj.angle = 0
				S_FadeOutStopMusic(4*MUSICRATE)
				
				local dist = R_PointToDist2(players[0].mo.x, players[0].mo.y, mobj.x, mobj.y)/2
				local thok = P_SpawnMobjFromMobj(players[0].mo,
				P_ReturnThrustX(nil, players[0].drawangle, dist*2/5),
				P_ReturnThrustY(nil, players[0].drawangle, -dist), 0, MT_THOK)
				thok.state = S_INVISIBLE
				thok.angle = ANGLE_270
				players[0].awayviewmobj = thok
				players[0].awayviewtics = -1
			end
		end
	end
end)

//Extra enemy HP
local caceehealth = {
	[MT_GFZFISH] = 1,
	[MT_DETON] = 1,
	[MT_SKIM] = 1,
	[MT_POPUPTURRET] = 1,
	[MT_CRUSHSTACEAN] = 1,
	[MT_BANPYURA] = 1,
	[MT_JETJAW] = 1,
	[MT_VULTURE] = 1,
	[MT_POINTY] = 1,
	[MT_MINUS] = 1,
	[MT_BUMBLEBORE] = 1,
	[MT_BUGGLE] = 1,
	[MT_SPINBOBERT] = 1,
	
	[MT_REDCRAWLA] = 3,
	[MT_REDBUZZ] = 3
}

//Invincibile enemies in the tutorial
local caceetutinv = {
	[MT_REDCRAWLA] = true,
	[MT_REDBUZZ] = true,
	[MT_FACESTABBER] = true
}

local UPPERTIME = 10 //Uppercut multihit window
local BURNFACTOR = TICRATE*3
local BURNTHRESHOLD = tr_trans40*BURNFACTOR
local BURNINCREASE = tr_trans80*BURNFACTOR

//Cacee hat object for the Fang showdown
freeslot("MT_CACEE_HAT")
mobjinfo[MT_CACEE_HAT] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}
addHook("MobjThinker", function(mobj)
	if mobj.state == S_INVISIBLE
	and mobj.tracer and mobj.tracer.valid
		if mobj.tracer.state == S_PLAY_CLING
			A_CapeChase(mobj, 26*FRACUNIT+1, 0)
			mobj.flags2 = $|MF2_LINKDRAW
		else
			P_InstaThrust(mobj, mobj.tracer.angle+ANGLE_45, -4*mobj.scale)
			P_SetObjectMomZ(mobj, FRACUNIT, false)
			mobj.skin = mobj.tracer.skin
			mobj.state = S_TAILSOVERLAY_STAND
			mobj.tracer = nil
			mobj.flags = $&~MF_NOGRAVITY
			mobj.flags2 = $&~MF2_LINKDRAW
			mobj.fuse = 3*TICRATE
		end
	elseif mobj.state != S_INVISIBLE
		mobj.momz = $-P_GetMobjGravity(mobj)/2
		mobj.rollangle = $+(mobj.state == S_TAILSOVERLAY_0DEGREES and -ANGLE_11hh or ANGLE_11hh)
	end
end, MT_CACEE_HAT)

//Cacee Explode object
//Handles enemies exploding when dying, allowing the actual enemy to do their
//normal death routine
freeslot("MT_CACEE_EXPLODE")
mobjinfo[MT_CACEE_EXPLODE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	deathstate = S_FBOMB_EXPL1,
	xdeathstate = S_FBOMB_EXPL1,
	deathsound = sfx_ceboom,
	reactiontime = 0,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}
addHook("MobjFuse", function(mobj)
	mobj.scale = mobj.originscale
	mobj.momx = 0
	mobj.momy = 0
	mobj.momz = 0
	P_KillMobj(mobj)
	S_StartSound(mobj, mobj.info.deathsound)
	return true
end, MT_CACEE_EXPLODE)

//Cacee Flash object
//Handles enemy flashing and stun when delt partial damage by Cacee
freeslot("MT_CACEE_FLASH")
mobjinfo[MT_CACEE_FLASH] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}
addHook("MobjThinker", function(mobj)
	if not mobj.target return end
	if not (mobj.target and mobj.target.valid and not mobj.target.health)
		A_CapeChase(mobj,0,0)
	end
	if not (mobj and mobj.valid) return end
	if mobj.fuse%2 or mobj.fuse <= TICRATE/2-7
		mobj.state = S_INVISIBLE
	elseif mobj.target and mobj.target.valid
		if mobj.target.health
			if mobj.target.type == MT_ROSY
				mobj.target.state = S_ROSY_PAIN
			end
			P_SetMobjStateNF(mobj, mobj.target.state)
			mobj.tics = -1
			mobj.colorized = true
			mobj.color = SKINCOLOR_SUPERSILVER1
		else
			mobj.target.flags = $&~MF_NOTHINK
			P_KillMobj(mobj)
		end
	end
end, MT_CACEE_FLASH)
addHook("MobjFuse", function(mobj)
	if mobj.target and mobj.target.valid
		mobj.target.flags = $&~MF_NOTHINK
	end
end, MT_CACEE_FLASH)

//Followitem used for fire resistence
freeslot("MT_CACEE_BURN")
mobjinfo[MT_CACEE_BURN] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	dispoffset = 2,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}
addHook("FollowMobj", function(player, mobj)
	if not (player.mo and player.mo.valid and mobj and mobj.valid) return true end
	mobj.flags2 = $&~MF2_LINKDRAW
	if player.caceeburn
		mobj.skin = player.mo.skin
		mobj.state = player.mo.state
		mobj.frame = player.mo.frame|(min(max(NUMTRANSMAPS-player.caceeburn/BURNFACTOR,0),tr_trans90)<<FF_TRANSSHIFT)
		mobj.sprite2 = player.mo.sprite2
		mobj.angle = player.drawangle
		mobj.color = SKINCOLOR_KETCHUP
		mobj.colorized = true
		mobj.scale = player.mo.scale
		mobj.radius = player.mo.radius
		mobj.height = player.mo.height
		mobj.flags2 = player.mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
		mobj.eflags = player.mo.eflags&MFE_VERTICALFLIP
	elseif mobj.state != S_INVISIBLE
		mobj.state = S_INVISIBLE
	end
	P_TeleportMove(mobj,player.mo.x,player.mo.y,player.mo.z)
	return true
end, MT_CACEE_BURN)

//Spawns objects in a circle
local function caceecircle(mobj, mobjtype, amount, ns, zoffset, scale, keepmom, color, vertical, vertangle)
	local i = 0	while i < amount
		local fa = i*(ANGLE_180/(amount/2))
		local mo = P_SpawnMobjFromMobj(mobj,0,0,zoffset,mobjtype)
		if mo and mo.valid
			local height = mo.height
			mo.scale = scale
			mo.target = mobj
			if mobj.eflags&MFE_VERTICALFLIP
				mo.z = $-(mo.height-height)
			end
			if mobjtype == MT_MINECARTSPARK
				mo.fuse = TICRATE
			end
			if color
				mo.color = color
				mo.colorized = true
			end
			if mo.type == MT_THOK
				mo.colorized = false
				mo.fuse = mo.tics
			end
			if vertical
				mo.momz = FixedMul(sin(fa),ns)
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns))
			else
				mo.momx = FixedMul(sin(fa),ns)
				mo.momy = FixedMul(cos(fa),ns)
			end
			if keepmom
				mo.momx = $+mobj.momx
				mo.momy = $+mobj.momy
				mo.momz = $+mobj.momz
			end
		end
		i = $+1
	end
end

//Custom version of P_NukeEnemies that will hit monitors and spikes
local nukepunch = function(player, radius, candamage, wind)
	local mo = player.mo
	local thokmobj = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
	thokmobj.radius = radius
	thokmobj.flags2 = $|MF2_DONTDRAW
	searchBlockmap("objects", function(refmobj, mobj)
		if not (mobj and mobj.valid and mobj.health and mobj != mo)
			return
		end
		
		if candamage
		and (not P_PlayerCanDamage(player, mobj) or mobj.flags&(MF_NOCLIP|MF_NOCLIPTHING))
			return
		end
		
		if wind and (mobj.flags&MF_NOGRAVITY or mobj.flags&MF_MONITOR
		or mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
		or mobj.type == MT_BLACKEGGMAN or mobj.type == MT_CYBRAKDEMON)
			return
		end
		
		if not (mobj.flags & MF_SHOOTABLE) and mobj.type != MT_EGGGUARD and mobj.type != MT_MINUS
		and mobj.type != MT_METALSONIC_BATTLE and mobj.type != MT_WALLSPIKE
		and (mobj.type != MT_SPIKE or (P_IsObjectOnGround(mo)
		and not (mo.eflags&MFE_ONGROUND) and player.caceepunch
		and player.caceepunch <= 2))
			return
		end

		if mobj.player
			if mobj.player.spectator
				return
			elseif not CV_FindVar("friendlyfire").value
			and G_GametypeHasTeams() and mobj.player.ctfteam == player.ctfteam
				return
			elseif G_TagGametype() and (mobj.player.pflags & PF_TAGIT) == (player.pflags & PF_TAGIT)
				return
			elseif not CV_FindVar("friendlyfire").value and not G_RingSlingerGametype()
			and not (CBW_Battle and CBW_Battle.BattleGametype())
				return
			elseif not candamage and not P_IsObjectOnGround(mobj)
				return
			end
			
			if wind and P_IsObjectOnGround(mobj)
				P_ResetPlayer(mobj.player)
				mobj.player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_THOKKED
				mobj.state = S_PLAY_FALL
			end
		end

		if abs(mo.x - mobj.x) > radius or abs(mo.y - mobj.y) > radius or abs(mo.z - mobj.z) > radius
			return // Workaround for possible integer overflow in the below -Red
		end

		if FixedHypot(R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y),
		(mo.z - mobj.z)*(wind and 4 or 2)) > radius
			return
		end

		if not candamage and mobj.type == MT_MINUS
		and not (mobj.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mobj.flags = (mobj.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end

		if not candamage and mobj.type == MT_EGGGUARD and mobj.tracer //nuke Egg Guard's shield!
			P_KillMobj(mobj.tracer, mo, mo, 0)
			return
		end
		
		if mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
			P_KillMobj(mobj, mo, mo, 0) //just murder spikes!
			return
		end
		
		//Uppercut wind!
		if wind
			if mo.player.caceeuppermomz
				mobj.momz = mo.player.caceeuppermomz*2
			else
				mobj.momz = mo.momz
			end
			
		//That's right, we're doing this the hard way.
		elseif mobj.type == MT_METALSONIC_BATTLE and mobj.state == S_METALSONIC_FLOAT
			mobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh),
			FixedDiv((mobj.info.spawnhealth - mobj.health)<<FRACBITS, (mobj.info.spawnhealth-1)<<FRACBITS)))
			if (P_RandomChance(FRACUNIT/2)) then mobj.movedir = InvAngle(mobj.movedir) end
			mobj.threshold = 6 + (FixedMul(24<<FRACBITS, FixedDiv((mobj.info.spawnhealth - mobj.health)<<FRACBITS, (mobj.info.spawnhealth-1)<<FRACBITS))>>FRACBITS)
			if (mobj.info.activesound) then S_StartSound(mobj, mobj.info.activesound) end
			if (mobj.info.painchance) then mobj.state = mobj.info.painchance end
			mobj.flags2 = $ & ~MF2_INVERTAIMABLE
			
		elseif candamage and mobj.player and CBW_Battle and CBW_Battle.BattleGametype()
			CBW_Battle.PlayerTouch(mo,mobj)
			
		//Unlike the orignal script this always deals one damage, no matter what
		else
			P_DamageMobj(mobj, mo, mo, 1, 0)
		end
	end, thokmobj)
end

//When you hit a thing
local punchknockback = function(player, mobj)
	local mo = player.mo
	if player.caceepunch or mo.state == S_PLAY_TWINSPIN
		local angle = R_PointToAngle2(mobj.x,mobj.y,mo.x-mo.momx,mo.y-mo.momy)
		
		//Punchin'
		if player.caceepunch
			//Vertical
			if P_IsObjectOnGround(mo)
				mo.z = $+P_MobjFlip(mo)
				mo.momz = abs(P_GetMobjGravity(mo))*P_MobjFlip(mo)
			else
				mo.momz = abs(P_GetMobjGravity(mo)*8)*P_MobjFlip(mo)
			end
			
			//Horizontal
			P_InstaThrust(mo, angle, (player.caceepunch < 3 and 20 or 10)*mo.scale)
			
			//Underwater drag
			if mo.eflags&MFE_UNDERWATER
				mo.momx = $*2/3 mo.momy = $*2/3
			end
			
			//States
			if mo.state != S_PLAY_MELEE_FINISH and player.caceepunch == 1
				mo.state = S_PLAY_STND
				mo.state = S_PLAY_MELEE_FINISH
				mo.state = S_PLAY_MELEE_FINISH
				mo.state = S_PLAY_MELEE_FINISH
				mo.state = S_PLAY_MELEE_FINISH
			elseif mo.state != S_PLAY_FIRE_FINISH and player.caceepunch == 2
				mo.state = S_PLAY_STND
				mo.state = S_PLAY_FIRE_FINISH
				mo.state = S_PLAY_FIRE_FINISH
				mo.state = S_PLAY_FIRE_FINISH
				mo.state = S_PLAY_FIRE_FINISH
			end
			
		//Uppercuttin'
		elseif mo.state == S_PLAY_TWINSPIN
			//Multihit
			if player.caceeuppertimer and not mobj.player
				player.pflags = $&~PF_JUMPED
				P_DoJump(player, false)
				player.caceeupperspeed = player.speed
				player.caceeuppermomz = mo.momz
				player.caceeupperangle = player.drawangle
				player.caceeuppertimer = UPPERTIME
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				player.pflags = $|PF_FULLSTASIS
				
				mo.state = S_PLAY_STND
				mo.state = S_PLAY_TWINSPIN
				player.panim = PA_DASH
			//Normal hit
			else
				if mo.momz*P_MobjFlip(mo) > 0
					mo.momz = abs($)*P_MobjFlip(mo)/-4
				end
				P_InstaThrust(mo, angle, player.speed)
			end
		end
		
		if not P_IsObjectOnGround(mo)
			player.pflags = $|P_GetJumpFlags(player)
		end
		player.pflags = $&~PF_THOKKED&~PF_SHIELDABILITY
	end
end

//What it says on the tin
local breakfloor = function(mo)
	if mo.subsector and mo.subsector.valid
	and mo.subsector.sector and mo.subsector.sector.valid
		local crumble = false
		for fof in mo.subsector.sector.ffloors()
			if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
			if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
			
			if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
			if mo.z + mo.momz > fof.topheight continue end -- Are we too high?  
			
			EV_CrumbleChain(fof) -- Crumble
		end
	end
end

//You're an idiot for touching a cactus
local hugpain = function(player, inflictor)
	local ang = player.drawangle
	local fallbackspeed = FixedMul(4*FRACUNIT, player.mo.scale)

	P_ResetPlayer(player)
	player.pflags = $|PF_THOKKED
	player.mo.silv_floatstate = 0
	player.mo.state = S_PLAY_STUN
	if (player.mo.eflags & MFE_VERTICALFLIP)
		player.mo.z = $-1
	else
		player.mo.z = $+1
	end

	if (player.mo.eflags & MFE_UNDERWATER)
		P_SetObjectMomZ(player.mo, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
	else
		P_SetObjectMomZ(player.mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
	end

	if inflictor and inflictor.valid
		ang = R_PointToAngle2(inflictor.x-inflictor.momx, inflictor.y - inflictor.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)
		fallbackspeed = FixedMul(4*FRACUNIT, inflictor.scale) // the usual amount of force
	elseif player.mo.momx or player.mo.momy
		ang = R_PointToAngle2(player.mo.momx, player.mo.momy, 0, 0)
	end

	player.drawangle = ang + ANGLE_180
	P_InstaThrust(player.mo, ang, fallbackspeed)
	S_StartSound(player.mo, sfx_spkdth)
end

//Reset deez
local resetcacee = function(player)
	player.caceespike = 0
	if player.caceepunch and player.realmo and player.realmo.valid
		player.camerascale = skins[player.realmo.skin].camerascale
	end
	player.caceepunch = 0
	player.caceethrust = 0
	player.caceeupperspeed = nil
	player.caceeuppermomz = nil
	player.caceeupperangle = player.drawangle
	player.caceeuppertimer = 0
	player.caceeupperstart = false
	if player.caceeburn == nil or leveltime <= 2 or player.spectator
	or player.playerstate or player.iseggrobo or player.isjettysyn
		player.caceeburn = 0
	end
	player.caceecrisp = false
end

//Initalize the variables
for player in players.iterate
	 resetcacee(player)
end

//Get the player's input angle
local function getinputangle(player)
	if P_GetPlayerControlDirection(player) == 0
	or player.mo.flags2 & MF2_TWOD or twodlevel
		return player.drawangle
	else 
		return player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
	end
end

addHook("PlayerSpawn", resetcacee)

//Main character thinker
addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cacee") then return end
	local mo = player.mo
	
	//Fang showdown
	if mo.caceefang and mo.caceefang.valid
		local fang = mo.caceefang
		
		if P_PlayerInPain(player) or not mo.health
			mo.caceefang = nil
			mo.caceefangtimer = 0
			mo.reactiontime = 0
			if player.awayviewmobj and player.awayviewmobj.valid
				P_KillMobj(player.awayviewmobj)
			end
			S_ChangeMusic("VSFANG", true, player, nil, MUSICRATE*1457/250)
			return
		end
		
		if player.cmd.buttons == 0 then
			mo.caceeguntapready = true
			mo.caceeguntapping = false
		elseif mo.caceeguntapready then
			mo.caceeguntapping = true
			mo.caceeguntapready = false
		else
			mo.caceeguntapping = false
		end
		
		mo.angle = ANGLE_225
		player.drawangle = ANGLE_225
		
		if fang.state == S_FANG_INTRO9
			P_SetMobjStateNF(fang, S_FANG_IDLE1)
			S_ChangeMusic("MXSTNDF", false, player)
		end
		
		if fang.state >= S_FANG_IDLE1 and fang.state <= S_FANG_IDLE8
		and fang.tics == 1
			P_SetMobjStateNF(fang, states[fang.state].nextstate)
		end
		
		if mo.caceefangtimer
			mo.caceefangtimer = $+1
			if mo.caceefangtimer >= 8*TICRATE
				if mo.caceefangtimer == 8*TICRATE
					local dist = R_PointToDist2(mo.x, mo.y, fang.x, fang.y)/2
					local thok = P_SpawnMobjFromMobj(mo,
					P_ReturnThrustX(nil, player.drawangle, dist*2/5),
					P_ReturnThrustY(nil, player.drawangle, dist), 0, MT_THOK)
					thok.state = S_ALART1
					S_StartSound(thok, sfx_rail1)
					thok.fuse = TICRATE 
				end
				
				if mo.state == S_PLAY_CLING
				and mo.caceeguntapping
				and mo.caceefangtimer < 17*TICRATE/2
					mo.state = S_PLAY_CLIMB
					mo.tics = -1
					
					local zpos = function(posmo)
						return posmo.z + (posmo.height - mobjinfo[player.revitem].height)/2
					end
					
					local bullet = P_SpawnPointMissile(mo, fang.x, fang.y,
					zpos(fang), player.revitem, mo.x, mo.y, zpos(mo))
				end
				
				if mo.caceefangtimer == 17*TICRATE/2 and mo.state == S_PLAY_CLING
					fang.target = mo
					fang.state = S_FANG_FIRE1
					fang.extravalue2 = 1
				end
				
				if mo.caceefangtimer >= 9*TICRATE
				and player.awayviewmobj and player.awayviewmobj.valid
					P_KillMobj(player.awayviewmobj)
				end
				
				if mo.caceefangtimer >= 10*TICRATE
					mo.caceefang = nil
					mo.caceefangtimer = 0
					mo.reactiontime = 0
					mo.state = S_PLAY_STND
					
					if mapheaderinfo[gamemap].muspostbossname
						S_ChangeMusic(mapheaderinfo[gamemap].muspostbossname, true, player)
					end
					
					local gun = P_SpawnMobjFromMobj(mo,
					P_ReturnThrustX(nil,mo.angle,16*FRACUNIT),
					P_ReturnThrustY(nil,mo.angle,16*FRACUNIT),0,MT_CACEE_HAT)
					gun.skin = mo.skin
					gun.state = S_TAILSOVERLAY_0DEGREES
					gun.flags = $&~MF_NOGRAVITY
					gun.angle = mo.angle-ANGLE_45
					P_InstaThrust(gun, gun.angle, 4*gun.scale)
					P_SetObjectMomZ(gun, 4*FRACUNIT, false)
				end
			end
		else
			mo.caceefangtimer = P_RandomKey(TICRATE*2)+1
		end
		return
	elseif mo.caceefangtimer
		mo.caceefangtimer = 0
		mo.reactiontime = 0
		mo.state = S_PLAY_STND
		if player.awayviewmobj and player.awayviewmobj.valid
			P_KillMobj(player.awayviewmobj)
		end
	end
	
	//Wait speed
	if player.mo.state == S_PLAY_WAIT
		player.mo.anim_duration = min($,5)
	end
	
	//Skid animation
	if mo.state == S_PLAY_SKID
		local tics = mo.tics
		if not (tics%4)
			mo.state = S_PLAY_SKID
			mo.tics = tics
		end
	end
	
	//Burn timer
	if player.caceeburn
		if mo.eflags&MFE_UNDERWATER and not (mo.eflags&MFE_TOUCHLAVA)
			player.caceeburn = 0
			S_StartSound(mo, sfx_s3k4b)
		else
			if player.caceeburn >= BURNTHRESHOLD and leveltime%4 == 0
				local smoke = P_SpawnMobjFromMobj(mo,25*(P_RandomFixed()-(FRACUNIT/2)),
				50*(P_RandomFixed()-(FRACUNIT/2)),
				(50*(P_RandomFixed()-(FRACUNIT/2)))+(mo.height/2),MT_SMOKE)
				smoke.momx = mo.momx/2
				smoke.momy = mo.momy/2
				smoke.momz = mo.momz/2
			end
			
			if not player.powers[pw_flashing]
				player.caceeburn = $-1
			end
		end
	end
	
	//Carry body damage
	if player.powers[pw_carry] and mo.tracer and mo.tracer.valid
	and (mo.tracer.flags&MF_SHOOTABLE or mo.tracer.flags&MF_ENEMY
	or mo.tracer.flags&MF_BOSS) and not mo.tracer.player
		if mo.tracer.flags&MF_ENEMY or mo.tracer.flags&MF_BOSS
			player.powers[pw_flashing] = max($,TICRATE)
		end
		P_DamageMobj(mo.tracer, mo, mo, 1, DMG_SPIKE)
		P_ResetPlayer(player)
		mo.momx = mo.caceemomx
		mo.momy = mo.caceemomy
		mo.momz = mo.caceemomz
		player.pflags = $|PF_JUMPED&~PF_STARTJUMP&~PF_THOKKED
		mo.state = S_PLAY_JUMP
	else
		mo.caceemomx = mo.momx
		mo.caceemomy = mo.momy
		mo.caceemomz = mo.momz
	end
	
	//Body damage for other players
	if (player.hugged and player.hugged.valid
	and player.hugged.mo and player.hugged.mo.valid
	and (player.hugged.hugging == player or player.hugged.hug == player)
	and player.hugged.mo.skin != "cacee"
	and not player.hugged.powers[pw_flashing]
	and not player.hugged.powers[pw_invulnerability]
	and not player.hugged.powers[pw_super])
	or (player.powers[pw_carry] == CR_PLAYER and mo.tracer and mo.tracer.valid
	and mo.tracer.player and mo.tracer.skin != "cacee"
	and not mo.tracer.player.powers[pw_flashing]
	and not mo.tracer.player.powers[pw_invulnerability]
	and not mo.tracer.player.powers[pw_super])
		player.caceehugpain = $+1
		if player.caceehugpain >= 5
			
			if player.powers[pw_carry] == CR_PLAYER
				hugpain(mo.tracer.player, mo)
				P_ResetPlayer(player)
			else
				player.hugged.hugging = nil
				player.hugged.hug = nil
				hugpain(player.hugged, mo)
			end
			
			player.hugged = nil
			player.caceehugpain = TICRATE/2
		end
	elseif player.caceehugpain == nil
		player.caceehugpain = 0
	elseif player.caceehugpain
		player.caceehugpain = $-1
	end
	
	//Disallows the rest of the code in certain circumstances
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	//or player.exiting
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not mo.health
	or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and mo.state == S_PLAY_FACEPLANT)
		//Fire death
		if player.playerstate == PST_DEAD
			if player.caceecrisp
				mo.colorized = true
				mo.color = SKINCOLOR_BLACK
				S_StartSound(mo, sfx_s3k4b)
				S_StartSound(mo, sfx_s3k48)
			elseif mo.colorized and mo.color == SKINCOLOR_BLACK
				local smoke = P_SpawnMobjFromMobj(mo,25*(P_RandomFixed()-(FRACUNIT/2)),
				50*(P_RandomFixed()-(FRACUNIT/2)),
				(50*(P_RandomFixed()-(FRACUNIT/2)))+(mo.height/2),MT_SMOKE)
			end
		end
		
		resetcacee(player)
		return
	end
	
	//Punch
	if player.caceepunch
		local angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
		if not mo.momx and not mo.momy
			angle = player.drawangle
		end
		
		local thrust = player.caceethrust
		//if P_IsObjectOnGround(mo)
		//	thrust = $*9/8
		//end
		
		local camscale = skins["cacee"].camerascale
		if player.camerascale > camscale
			player.camerascale = max($*19/20, camscale)
		elseif player.camerascale < camscale
			player.camerascale = min($*21/20, camscale)
		end
		
		if mo.eflags & MFE_SPRUNG
			player.mo.momz = $*5/4
			player.mo.momx = $*5/4
			player.mo.momy = $*5/4
			S_StartSound(mo, sfx_sprong)
		end
		
		//Earthquake
		if player.caceepunch == 3 and (P_IsObjectOnGround(mo)
		or mo.eflags & (MFE_SPRUNG|MFE_JUSTHITFLOOR))
			if abs(player.cmd.angleturn<<16 - angle) > ANGLE_90
				player.camerascale = camscale*4/3
			else
				player.camerascale = camscale*3/4
			end
			
			if player == displayplayer
				P_StartQuake(16*FRACUNIT, 5)
			end
			
			player.caceepunch = $+1
			S_StartSound(mo, sfx_cepun4)
			mo.state = S_PLAY_MELEE_LANDING
			player.panim = PA_DASH
			
			if not (mo.eflags & MFE_SPRUNG)
				mo.momx = 0 mo.momy = 0
			end
			
			local pounditem = MT_SUPERSPARK
			if player.powers[pw_shield] & SH_PROTECTFIRE
				S_StartSound(mo, sfx_fire)
				pounditem = MT_FIREBALLTRAIL
			elseif player.powers[pw_shield] & SH_PROTECTWATER
				local i=0 while i<4 S_StartSound(mo, sfx_bubbl1+i) i=$+1 end
				pounditem = MT_UWEXPLODE
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
					player.pflags = $&~PF_JUMPED|PF_THOKKED
					P_DoJump(player, false)
				end
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
				player.pflags = $|PF_SHIELDABILITY
				player.homing = 2
				mo.target = nil
				S_StartSound(mo, sfx_s3ka6)
			elseif player.powers[pw_shield] & SH_PROTECTELECTRIC
				S_StartSound(mo, sfx_s3k45)
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
				S_StartSound(mo, sfx_wdjump)
				pounditem = MT_TNTDUST
			elseif player.powers[pw_shield] & SH_FORCE
				S_StartSound(mo, sfx_ngskid)
				player.pflags = $|PF_SHIELDABILITY
			end
			
			caceecircle(mo, pounditem, 16, 32*mo.scale, 0, mo.scale, false, 0, false, player.drawangle)
			caceecircle(mo, MT_MINECARTSPARK, 8, 8*mo.scale, 0, mo.scale/4, false, 0, false, player.drawangle)
			
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = SKINCOLOR_SUPERGOLD2
			ghost.destscale = $*16
			if ghost.tracer and ghost.tracer.valid
				P_KillMobj(ghost.tracer)
			end
			
			nukepunch(player, FixedMul(RING_DIST*2/3, mo.scale))
			breakfloor(mo)
			
		//Cancel
		elseif player.panim != PA_ABILITY2 and player.panim != PA_DASH
		and mo.state != S_PLAY_GLIDE
			player.caceepunch = 0
			player.camerascale = camscale
			player.pflags = $&~PF_SHIELDABILITY
			
			if player.panim < PA_PAIN
				if P_IsObjectOnGround(mo)
					if player.speed >= FixedMul(player.runspeed, mo.scale)
						mo.state = S_PLAY_RUN
					elseif player.speed <= mo.scale
						mo.state = S_PLAY_STND
					else
						mo.state = S_PLAY_WALK
					end
				else
					mo.state = S_PLAY_FALL
				end
			end
			
		//Normal
		else
			nukepunch(player, 60*mo.scale, true)
			
			if P_IsObjectOnGround(mo) and player.caceepunch < 3
			and (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				P_ElementalFire(player)
			end
			
			if mo.state == S_PLAY_MELEE_FINISH or mo.state == S_PLAY_MELEE_LANDING
			or mo.state == S_PLAY_FIRE_FINISH
				mo.tics = min($, 10)
			end
			
			player.powers[pw_noautobrake] = max($, 5)
			player.skidtime = 0
			
			if player.caceepunch < 3 and mo.state != S_PLAY_MELEE_FINISH
			and mo.state != S_PLAY_FIRE_FINISH and not player.powers[pw_pushing]
			and not player.powers[pw_justlaunched] and not player.homing
			and not mo.pushed
				//if (mo.frame&FF_FRAMEMASK) == 0
				//	P_InstaThrust(mo, angle, mo.tics*thrust/5)
				//else
					P_InstaThrust(mo, angle, thrust)
				//end
				player.drawangle = angle
				if mo.eflags&MFE_UNDERWATER
					mo.momx = $*2/3 mo.momy = $*2/3
				end
			end
			player.panim = PA_DASH
		end
		
		//No jumping
		if player.caceepunch > 3 //or not P_IsObjectOnGround(mo)
		or (mo.state != S_PLAY_MELEE_FINISH and mo.state != S_PLAY_FIRE_FINISH
		and player.caceepunch == 3 and (mo.frame&FF_FRAMEMASK) == 0)
			player.pflags = $|PF_JUMPSTASIS
		end
		
		//Ghost effect
		if player.caceepunch and player.caceepunch <= 3 and leveltime%2
			/*
			local thok = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
			thok.target = mo
			thok.state = S_INVISIBLE
			thok.tics = 2
			A_CapeChase(thok, 16*FRACUNIT, 32*FRACUNIT + 12*((player.caceepunch == 2) and 1 or -1))
			thok.momx = mo.momx
			thok.momy = mo.momy
			thok.momz = mo.momz
			P_Thrust(thok, player.drawangle, -2*mo.scale)
			caceecircle(thok, MT_THOK, 16, 4*mo.scale, 0, mo.scale/4, true, SKINCOLOR_RED, true, player.drawangle)
			*/
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.color = player.caceepunch >= 3 and SKINCOLOR_SUPERGOLD2
			or (G_GametypeHasTeams() and player.ctfteam == 2 and SKINCOLOR_COBALT or SKINCOLOR_CRIMSON)
			if player.speed < mo.scale*5
				P_InstaThrust(ghost, angle, mo.scale*-5 + player.speed)
			end
			if ghost.tracer and ghost.tracer.valid
				P_KillMobj(ghost.tracer)
			end
		end
		
		//Break walls
		if not (player.pflags&PF_DRILLING)
			player.pflags = $|PF_DRILLING
			player.charflags = $|SF_NOSPEEDADJUST
			if SF_CANBUSTWALLS
				player.charflags = $|SF_CANBUSTWALLS
			else
				player.charability = CA_GLIDEANDCLIMB
			end
		end
		
		if player.powers[pw_super] or player.powers[pw_sneakers]
			player.normalspeed = max($,thrust/2)
		else
			player.normalspeed = max($,thrust)
		end
	
	//Uppercut
	elseif mo.state == S_PLAY_TWINSPIN
		if mo.frame&FF_FRAMEMASK > 1 and player.caceeuppermomz == nil
		and (mo.momz*P_MobjFlip(mo) < -4*mo.scale or P_IsObjectOnGround(mo))
			mo.state = S_PLAY_FALL
			mo.sprite2 = SPR2_TWIN
			player.caceeuppertimer = 0
		else
			local inputangle = getinputangle(player)
			
			if mo.frame&FF_FRAMEMASK > 1
				//No ending the animation!
				if mo.frame&FF_FRAMEMASK > 1
					mo.tics = -1
				end
				
				//Undo the momentum cancel
				if player.caceeupperspeed != nil and player.caceeuppermomz != nil
					P_InstaThrust(mo, inputangle,
					max(player.caceeupperspeed/2, player.caceeupperspeed-18*mo.scale))
					player.mo.momz = player.caceeuppermomz*2
					player.pflags = $|PF_STARTJUMP
					player.caceeupperstart = true
					
					nukepunch(player, 300*mo.scale, true, true) //Wind stuff
					
					player.caceeupperspeed = nil
					player.caceeuppermomz = nil
				end
				
				if player.caceeupperstart and not (player.pflags&PF_STARTJUMP)
					player.caceeupperstart = false
					nukepunch(player, 300*mo.scale, true, true) //Wind stuff
				end
				
				//Spinning (yoinked from Kart)
				local speed = max(1, min(8, mo.momz*P_MobjFlip(mo)/2/FRACUNIT))
				local angle = inputangle - player.caceeupperangle
				if angle > abs(ANGLE_180)
					angle = $+ANGLE_180*2
				elseif angle < ANGLE_180
					angle = $-ANGLE_180*2
				end
				if speed == 1 and abs(angle) < ANGLE_22h
					player.caceeupperangle = inputangle // Face forward at the end of the animation
				else
					player.caceeupperangle = $+(ANGLE_11hh * speed)
				end
				player.drawangle = player.caceeupperangle
				
				//Afterimage
				if leveltime%2 and mo.momz*P_MobjFlip(mo) > 0
					local ghost = P_SpawnGhostMobj(mo)
					ghost.colorized = true
					ghost.color = SKINCOLOR_ROSY
					if ghost.tracer and ghost.tracer.valid
						P_KillMobj(ghost.tracer)
					end
					
					breakfloor(mo)
				end
				
				//Extended hitbox
				nukepunch(player, 60*mo.scale, true)
			else
				player.pflags = $|PF_FULLSTASIS
			end
			
			//Break walls
			if not (player.pflags&PF_DRILLING)
				player.pflags = $|PF_DRILLING
				player.charflags = $|SF_NOSPEEDADJUST
				if SF_CANBUSTWALLS
					player.charflags = $|SF_CANBUSTWALLS
				else
					player.charability = CA_GLIDEANDCLIMB
				end
			end
			
			if player.caceeuppertimer
				player.caceeuppertimer = $-1
			end
			player.normalspeed = skins["cacee"].normalspeed/2
			player.panim = PA_DASH
		end
		
	//Stop breaking walls dummy
	elseif player.pflags&PF_DRILLING
		player.pflags = $&~PF_DRILLING
		player.charflags = $&~SF_NOSKID&~SF_NOSPEEDADJUST
		if SF_CANBUSTWALLS
			player.charflags = $&~SF_CANBUSTWALLS
		else
			player.charability = skins["cacee"].ability
		end
		
		player.caceeuppertimer = 0
		player.normalspeed = skins["cacee"].normalspeed
	end
	
	//Spike walk
	if player.caceespike
		if P_IsObjectOnGround(mo) and player.skidtime
		or (mo.state == S_PLAY_WALK or mo.state == S_PLAY_RUN)
		and mo.tics == 1 and (mo.frame&FF_FRAMEMASK == 3
		or mo.frame&FF_FRAMEMASK == (mo.state == S_PLAY_RUN and 1 or 7))
			S_StartSound(mo, sfx_s236)
			S_StopSoundByID(mo, sfx_skid)
		end
		player.caceespike = $-1
	end
end)

//Uppercut
addHook("AbilitySpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cacee"
	and (player.charability == CA_DOUBLEJUMP or player.charability == CA_GLIDEANDCLIMB)
	and not player.gotflag and not player.gotcrystal) then return end
	local mo = player.mo
	
	if not (player.pflags&PF_THOKKED) or player.charflags&SF_MULTIABILITY
		player.pflags = $&~PF_JUMPED
		P_DoJump(player, false)
		player.caceeupperspeed = player.speed
		player.caceeuppermomz = mo.momz
		player.caceeupperangle = player.drawangle
		player.caceeuppertimer = UPPERTIME
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		if player.caceepunch
			player.caceepunch = 0
			player.camerascale = skins["cacee"].camerascale
		end
		player.pflags = $|PF_THOKKED|PF_FULLSTASIS|PF_DRILLING&~PF_STARTJUMP
		player.charflags = $|SF_NOSPEEDADJUST
		if SF_CANBUSTWALLS
			player.charflags = $|SF_CANBUSTWALLS
		else
			player.charability = CA_GLIDEANDCLIMB
		end
		
		S_StartSound(mo, sfx_ceuppr)
		if P_RandomChance(FRACUNIT/70) then S_StartSound(mo, sfx_ceshok) end
		caceecircle(mo, MT_DUST, 16, 16*mo.scale, 0, mo.scale, false, 0, false, player.drawangle)
		mo.state = S_PLAY_STND
		mo.state = S_PLAY_TWINSPIN
		player.panim = PA_DASH
		//mo.tics = $*2
	end
	return true
end)

//Punch
addHook("SpinSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cacee") then return end
	local mo = player.mo
	
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not mo.health
	or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and (mo.state == S_PLAY_FACEPLANT
	or player.mo.state == S_PLAY_TRICKUP or player.mo.state == S_PLAY_TRICKDOWN))
	or P_SuperReady(player)
	or player.pflags&PF_SPINDOWN
	//or not P_IsObjectOnGround(mo)
	or mo.state == S_PLAY_MELEE or mo.state == S_PLAY_FIRE
	or ((mo.state == S_PLAY_MELEE_FINISH or mo.state == S_PLAY_FIRE_FINISH) and mo.tics >= 8)
	or player.caceepunch >= 3
		return
	end
	
	local angle = getinputangle(player)
	local lockon = P_LookForEnemies(player, false, false)
	local lockonvalid = lockon and lockon.valid
	
	if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and lockonvalid
	and not P_IsObjectOnGround(mo)
		player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
		mo.target = lockon
		mo.tracer = lockon
		mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
		S_StartSound(mo, sfx_s3k40)
		player.homing = 3*TICRATE
	elseif abs(player.cmd.forwardmove) <= 25 and abs(player.cmd.sidemove) <= 25
		player.caceethrust = min(max(10*mo.scale,player.speed),40*mo.scale)
	else
		player.caceethrust = max(40*mo.scale, player.speed)
		
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
			player.pflags = $|PF_SHIELDABILITY
			player.caceethrust = $*8/7
			S_StartSound(player.mo, sfx_s3k43)
		end
		
		if lockonvalid
		and abs((mo.z+mo.height/2)-(lockon.z+lockon.height/2)) <= mo.height*(P_IsObjectOnGround(mo) and 1 or 2)
			angle = R_PointToAngle2(mo.x,mo.y,lockon.x,lockon.y)
			
			if not P_IsObjectOnGround(mo)
				local z = mo.z + mo.height/2
				if (mo.eflags & MFE_VERTICALFLIP) then z = $-FixedMul(mo.height, mo.scale) end
				mo.momz = (lockon.z + lockon.momz - z) / max((P_AproxDistance(lockon.x + lockon.momx - mo.x, lockon.y + lockon.momy - mo.y)/max(player.caceethrust,1)),1)
				mo.momz = max(min($, mo.scale*16), mo.scale*-16)
			end
		end
	end
	
	if player.gotflagdebuff
		player.caceethrust = min($, FixedMul(player.normalspeed, mo.scale)+4*mo.scale)
	end
	
	P_InstaThrust(mo, angle, player.caceethrust)
	
	if mo.eflags&MFE_UNDERWATER
		mo.momx = $*2/3 mo.momy = $*2/3
	end
	
	player.drawangle = angle
	S_StartSound(mo, sfx_cepun1+player.caceepunch)
	player.caceepunch = $+1
	player.caceeuppertimer = 0
	
	local one = 3
	local two = 4
	if player.caceethrust < 40*mo.scale
		one = 6
		two = 7
	end
	
	if abs(player.cmd.angleturn<<16 - angle) > ANGLE_90
		player.camerascale = skins["cacee"].camerascale*one/two
	else
		player.camerascale = skins["cacee"].camerascale*two/one
	end
	
	player.powers[pw_noautobrake] = max($, 5)
	player.skidtime = 0
	player.charflags = $|SF_NOSKID|SF_NOSPEEDADJUST
	player.pflags = $|PF_FULLSTASIS|PF_DRILLING
	if SF_CANBUSTWALLS
		player.charflags = $|SF_CANBUSTWALLS
	else
		player.charability = CA_GLIDEANDCLIMB
	end
	
	mo.state = S_PLAY_STND
	mo.state = S_PLAY_MELEE
	mo.tics = $+1
	
	if player.caceepunch >= 3
		mo.z = $+P_MobjFlip(mo)
		mo.momz = abs(P_GetMobjGravity(mo)*8)*P_MobjFlip(mo)
		mo.eflags = $&~MFE_JUSTHITFLOOR
		mo.state = S_PLAY_GLIDE
		caceecircle(mo, MT_DUST, 16, 8*mo.scale, 0, mo.scale, false, 0, false, player.drawangle)
		
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			player.pflags = $|PF_SHIELDABILITY
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			S_StartSound(mo, sfx_s3k43)
			player.pflags = $|PF_SHIELDABILITY
		end
	elseif player.caceepunch == 2
		mo.state = S_PLAY_FIRE
		mo.tics = $+1
	end
	
	player.panim = PA_DASH
end)

//No Shields
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "cacee"
		return true
	end
end)

//Allow double jumps out of the Flame Shield
addHook("JumpSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "cacee"
	//and (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
	and player.pflags&PF_SHIELDABILITY and player.pflags&PF_JUMPED
	and not (player.pflags&(PF_THOKKED|PF_JUMPDOWN))
		player.pflags = $&~PF_SHIELDABILITY
	end
end)

//Punch Damage
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "cacee"
		local mo = player.mo
		if mo.state == S_PLAY_TWINSPIN or player.caceepunch >= 3
			return true
		elseif player.caceepunch
			local angle = player.drawangle - R_PointToAngle2(mo.x-mo.momx,
			mo.y-mo.momy, mobj.x, mobj.y)
			if angle > abs(ANGLE_180)
				angle = $+ANGLE_180*2
			elseif angle < ANGLE_180
				angle = $-ANGLE_180*2
			end
			if abs(angle) < ANGLE_90
				return true
			end
		end
	end
end)

//Destroy spikes via attacks
local waterspike = function(thing, tmthing)
	if thing and thing.valid and tmthing and tmthing.valid
	and tmthing.player and tmthing.skin == "cacee"
	and ((tmthing.player.caceepunch and tmthing.player.caceepunch <= 2)
	or tmthing.state == S_PLAY_TWINSPIN)
	and thing.z - thing.scale <= tmthing.z + tmthing.height + (tmthing.player.caceepunch and P_MobjFlip(tmthing) or tmthing.momz)
	and thing.z + thing.height + thing.scale >= tmthing.z + (tmthing.player.caceepunch and P_MobjFlip(tmthing) or tmthing.momz)
		P_KillMobj(thing, tmthing)
		return true
	end
end
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_WALLSPIKE)

//Well isn't this interesting?
addHook("MobjLineCollide", function(mo, line)
	if mapheaderinfo[gamemap].lvlttl == "Arid Canyon"
	and mapheaderinfo[gamemap].actnum == 2
	and mo and mo.valid and mo.player and gamemap == 14
	and line and line.valid and (#line == 7444 or #line == 7318 or #line == 7282)
		local player = mo.player
		if line.frontside.midtexture == 0
		and line.backside.midtexture == 0
			return false
		elseif mo.skin == "cacee" and player.caceepunch
		and line.frontside.midtexture == R_CheckTextureNumForName("ACMINES5")
		and line.backside.midtexture == line.frontside.midtexture
			line.frontside.midtexture = 0
			line.backside.midtexture = 0
			if #line == 7318 and lines[7282] and lines[7282].valid
				lines[7282].frontside.midtexture = 0
				lines[7282].backside.midtexture = 0
			elseif #line == 7282 and lines[7318] and lines[7318].valid
				lines[7318].frontside.midtexture = 0
				lines[7318].backside.midtexture = 0
			end
			caceecircle(mo, MT_WOODDEBRIS, 16, 8*mo.scale, player.height/2, mo.scale, false, 0, true, player.drawangle)
			S_StartSound(mo, sfx_wbreak)
			return false
		end
	end
end, MT_PLAYER)

//Body damage
addHook("MobjDamage", function(mo, inf, src, dmg, dmgtype)
	if not (dmgtype&DMG_DEATHMASK) and dmgtype != DMG_NUKE
	and mo and mo.valid and mo.skin == "cacee" and mo.player
	and inf and inf.valid and not (inf.flags&MF_MISSILE)
	and not (inf.flags&MF_NOCLIPTHING) and inf.flags&MF_SHOOTABLE
	and not inf.player
	and R_PointToDist2(mo.x,mo.y,inf.x,inf.y) <= (mo.radius+inf.radius)*2
	and abs((mo.z+mo.height/2)-(inf.z+inf.height/2)) <= mo.height+inf.height
		resetcacee(mo.player)
		P_DamageMobj(inf, mo, mo, 1, DMG_SPIKE)
	end
end, MT_PLAYER)

//Fire Resist
addHook("MobjDamage", function(mo, inf, src, dmg, dmgtype)
	if (dmgtype == DMG_FIRE or (inf and inf.valid and inf.flags&MF_FIRE))
	and mo and mo.valid and mo.skin == "cacee" and mo.player
	and not (mo.eflags&MFE_UNDERWATER and not (mo.eflags&MFE_TOUCHLAVA))
		local burn = mo.player.caceeburn
		mo.player.caceeburn = min($+BURNINCREASE, NUMTRANSMAPS*BURNFACTOR)
		mo.player.caceecrisp = true
		if burn < BURNTHRESHOLD
			P_DoPlayerPain(mo.player, inf, src)
			mo.state = S_PLAY_STUN
			S_StartSound(mo, sfx_shldls)
			return true
		end
	end
end, MT_PLAYER)

//Extra enemy health
addHook("MobjDamage", function(mobj, inf, src, dmg, dmgtype)
	if mobj and mobj.valid and not mobj.player and dmgtype != DMG_NUKE
	and mobj.health and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS)
		//No attacking this enemy when it's flashing
		if mobj.caceeflash and mobj.caceeflash.valid and mobj.caceeflash.fuse > TICRATE/2-7
			if inf and inf.valid and inf.player
				if inf.skin == "cacee" and inf.state == S_PLAY_TWINSPIN
				and inf.player.caceeuppertimer and not (mobj.flags&MF_BOSS
				and mobj.flags&MF_NOGRAVITY and mobj.type != MT_EGGMOBILE
				and mobj.type != MT_METALSONIC_BATTLE)
				and mobj.type != MT_BLACKEGGMAN and mobj.type != MT_CYBRAKDEMON
				and not (mapheaderinfo[gamemap].caceetutorial
				and caceetutinv[mobj.type] and mobj.flags&MF_NOGRAVITY)
					local flags = mobj.flags
					mobj.flags = $|MF_NOCLIPTHING&~MF_ENEMY&~MF_BOSS
					
					P_TryMove(mobj, mobj.x+inf.momx, mobj.y+inf.momy, true)
					mobj.z = inf.z+inf.momz+mobj.height/2
					
					mobj.flags = flags
				elseif mobj.info.spawnhealth > 1
					local angle = R_PointToAngle2(mobj.x,mobj.y,inf.x-inf.momx,inf.y-inf.momy)
					if inf.skin == "cacee" and inf.player.caceepunch
						P_InstaThrust(inf, angle, 20*inf.scale)
					else
						P_InstaThrust(inf, angle, inf.player.speed)
					end
				end
			end
			return true
		end
		
		//Skin and ability checks
		if inf and inf.valid and inf.player and inf.skin == "cacee"
			if not inf.player.caceepunch and dmgtype != DMG_SPIKE
			and inf.state != S_PLAY_TWINSPIN
				return
			end
		elseif not (src and src.valid and src.player and src.skin == "cacee"
		and inf and inf.valid and inf.type == src.player.revitem)
			return
		elseif src.caceefang == mobj
			P_LinedefExecute(65531)
			P_KillMobj(mobj)
		end
		
		local damagesound = dmgtype == DMG_SPIKE and sfx_cehit2 or sfx_cehit1
		
		if inf and inf.valid and inf.player and inf.skin == "cacee"
			if inf.player.caceepunch >= 4
				mobj.caceepain = 99
			else
				if inf.player.powers[pw_super]
					mobj.caceepain = 99
				end
				punchknockback(inf.player, mobj)
			end
		end
		
		if mobj.caceepain == nil mobj.caceepain = 0 end
		
		if (mobj.caceepain+1 >= (caceehealth[mobj.type] or 2)
		or mobj.info.spawnhealth == 0)
		and not (mapheaderinfo[gamemap].caceetutorial and caceetutinv[mobj.type])
			mobj.caceepain = 0
			if mobj.health <= 1 and mobj.flags&MF_ENEMY
				if mobj.caceeflash and mobj.caceeflash.valid
					P_KillMobj(mobj.caceeflash)
					mobj.caceeflash = nil
					mobj.flags = $&~MF_NOTHINK
				end
				local explode = P_SpawnMobjFromMobj(mobj,0,0,0,MT_CACEE_EXPLODE)
				P_SetMobjStateNF(explode, mobj.state)
				explode.tics = -1
				explode.colorized = mobj.colorized
				explode.color = mobj.color
				explode.angle = mobj.angle
				explode.originscale = mobj.scale
				explode.destscale = mobj.scale*16
				explode.scalespeed = mobj.scale/8
				explode.fuse = TICRATE/4
				if inf and inf.valid and inf.player and inf.skin == "cacee"
				and inf.player.caceeuppertimer
					explode.momx = inf.momx
					explode.momy = inf.momy
					explode.momz = inf.momz
				end
				S_StartSound(explode,damagesound)
				P_KillMobj(mobj, inf, src)
				S_StopSoundByID(mobj, mobj.info.deathsound)
				mobj.flags2 = MF2_DONTDRAW
				mobj.tics = 2
				return true
			else
				S_StartSound(mobj,damagesound)
			end
		else
			if not mobj.caceepain
				mobj.caceepain = 1
			else
				mobj.caceepain = $+1
			end
			S_StartSound(mobj,damagesound)
			P_SpawnMobjFromMobj(mobj,0,0,0,MT_SONIC3KBOSSEXPLODE)
			caceecircle(mobj, MT_MINECARTSPARK, 3, 4*mobj.scale, 0, mobj.scale/4, false, 0, true, mobj.angle)
			mobj.caceeflash = P_SpawnMobjFromMobj(mobj,0,0,0,MT_CACEE_FLASH)
			mobj.caceeflash.target = mobj
			mobj.caceeflash.fuse = TICRATE/2
			if mobj.type == MT_PTERABYTE
				mobj.target = nil
			end
			if mobj.tics > 0
				mobj.tics = max($, TICRATE/2)
			end
			if mobj.info.painstate and states[mobj.info.painstate]
				mobj.sprite = states[mobj.info.painstate].sprite
				mobj.frame = states[mobj.info.painstate].frame
			end
			mobj.flags = $|MF_NOTHINK
			return true
		end
	end
end)

//An object damaging while they're flashing? No way!
addHook("ShouldDamage", function(mobj, inf)
	if inf and inf.valid and inf.caceeflash and inf.caceeflash.valid
		return false
	end
end)

//The funny
addHook("MobjMoveCollide", function(mobj, mo)
	if mobj and mobj.valid and mo and mo.valid and mo.skin == "cacee"
	and mo.player and not (mobj.caceeflash and mobj.caceeflash.valid and mobj.caceeflash.fuse > TICRATE/2-7)
	and mobj.z - mobj.scale <= mo.z + mo.height
	and mobj.z + mobj.height + mobj.scale >= mo.z
	and R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y) <= mo.radius*3
		local angle = R_PointToAngle2(mobj.x,mobj.y,mo.x-mo.momx,mo.y-mo.momy)
		if mo.player.caceepunch
			punchknockback(mo.player, mobj)
		
			S_StartSound(mobj,sfx_cehit1)
			P_SpawnMobjFromMobj(mobj,0,0,0,MT_SONIC3KBOSSEXPLODE)
			mobj.caceeflash = P_SpawnMobjFromMobj(mobj,0,0,0,MT_CACEE_FLASH)
			mobj.caceeflash.target = mobj
			mobj.caceeflash.fuse = TICRATE/2
			mobj.flags = $|MF_NOTHINK
			mobj.state = S_ROSY_PAIN
			mobj.z = $-P_GetMobjGravity(mobj)
			mobj.angle = angle
			mobj.cvmem = $-TICRATE
		elseif mobj.target == mo and mobj.state != S_ROSY_PAIN
			mobj.state = S_ROSY_PAIN
			S_StartSound(mobj, sfx_cdpcm7)
			S_StartSound(mobj, sfx_spkdth)
			A_DoNPCPain(mobj)
			mobj.angle = angle
			mobj.cvmem = $-TICRATE
		end
	end
end, MT_ROSY)

//Partial Spike immunity
addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if mo and mo.valid and mo.skin == "cacee" and mo.player
	and (dmgtype == DMG_SPIKE or (inf and inf.valid and (inf.type == MT_SPIKE or inf.type == MT_WALLSPIKE)))
	and not (inf and inf.valid and (inf.flags&MF_MISSILE or inf.flags&MF_PAIN
	or inf.flags&MF_ENEMY or inf.flags&MF_BOSS))
		if not mo.player.caceespike
			S_StartSound(mo, sfx_s255)
		end
		mo.player.caceespike = 2
		return false
	end
end, MT_PLAYER)

//Cactus love
addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if mo and mo.valid and mo.skin == "cacee" and mo.player
	and inf and inf.valid and inf.type >= MT_CACTI1 and inf.type <= MT_CACTISMALLSEG
		if P_IsObjectOnGround(mo) and mo.player.speed < 8*mo.scale
		and (mo.player.panim == PA_IDLE or mo.player.panim == PA_WALK)
			if not (leveltime&15)
				local cdlhrt = P_SpawnMobjFromMobj(mo, 0, 0, mo.player.height, MT_CDLHRT)
				cdlhrt.scale = (5*mo.scale) >> 4
				cdlhrt.fuse = (5*TICRATE) >> 1
				cdlhrt.momz = mo.scale
				cdlhrt.target = mo
				cdlhrt.extravalue1 = mo.x
				cdlhrt.extravalue2 = mo.y
			end
			mo.player.drawangle = R_PointToAngle2(mo.x,mo.y,inf.x,inf.y)
		end
		return false
	end
end, MT_PLAYER)

//Battle Mod Support
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	
	local function GarbagePriority4(player)
		if player.caceepunch
			CBW_Battle.SetPriority(player,0,0,"amy_melee",1,1,"Spike Rush combo")
		elseif player.mo.state == S_PLAY_TWINSPIN
			CBW_Battle.SetPriority(player,1,1,"tails_fly",2,2,"Rocket Upper")
		end
		
		if (not player.battle_atk and not player.battle_def
		and player.battle_sfunc == "can_damage" and not P_PlayerInPain(player)
		and (player.panim < PA_PAIN or (player.panim >= PA_JUMP or player.panim <= PA_FALL)))
		or player.caceepunch >= 4
			CBW_Battle.SetPriority(player,1,0,nil,1,0,"spikey cactus body")
		end
	end
	
	CBW_Battle.SkinVars["cacee"] = {
		weight = 75,
		func_priority_ext = GarbagePriority4
	}
end)

//Behavior when damaging other players (guess this works for Match too?)
addHook("MobjDamage", function(mo, inf, src, dmg, dmgtype)
	if mo and mo.valid and mo.player
	and inf and inf.valid and inf.skin == "cacee" and inf.player
		local angle = R_PointToAngle2(mo.x,mo.y,inf.x-inf.momx,inf.y-inf.momy)
		
		if inf.player.battle_hurttxt == "spikey cactus body"
			S_StartSound(mo, sfx_cehit2)
		elseif (inf.player.caceepunch and inf.player.caceepunch <= 3)
		or inf.state == S_PLAY_TWINSPIN
			S_StartSound(mo, sfx_cehit1)
			punchknockback(inf.player, mo)
		end
	end
end, MT_PLAYER)